﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ServiceModel.Security;
using System.Web.Security;
using HLWebOKBQueryPlugin.OKBQueryService;
using HLWebOKBQueryPlugin.Helpers;

namespace HLWebOKBQueryPlugin.Models
{
    public class QueryModel {

        public String SelectedSubMenu { get; set; }
        private long[] runs;



        public IList<Filter> QueryFilterGetAll() {
            QueryServiceClient client = Query.GetClientFactory();

            IList<Filter> filterList = new List<Filter>();

            if (client != null) {
                Filter[] filters = client.GetFilters();
                foreach (Filter f in filters) {
                    filterList.Add(f);

                }
            }

            return filterList;
        }

        public RunCollectionData getRun(long id) {
            QueryServiceClient client = Query.GetClientFactory();

            if (client != null) {
                Run run = client.GetRuns(new long[1] { id }, false).ToList<Run>().First();
                RunCollectionData rcd = new RunCollectionData(run);

                return rcd;
            }
            return null;
        }


        public long[] Runs
        {
            get
            {
                return this.runs;
            }
            set
            {
                this.runs = value;
            }

        }


        public IList<RunCollectionData> RunCollection
        {
            get
            {
                QueryServiceClient client = Query.GetClientFactory();
                if (client != null)
                {
                    IList<RunCollectionData> runCollection = new List<RunCollectionData>();

                    IList<Run> runList = client.GetRuns(runs, false).ToList<Run>();

                    foreach (Run r in runList)
                        runCollection.Add(new RunCollectionData(r));

                    return runCollection;
                }
                return new List<RunCollectionData>();
            }
        }

        // just 4 testing
        //public IList<RunCollectionData> getTestRuns() {

        //    QueryServiceClient client = Query.GetClientFactory();

        //    if (client != null) {
        //        IList<RunCollectionData> runs = new List<RunCollectionData>();

        //        //long[] runIds = client.GetRunIds(new Filter());
        //        //if (runIds.Length < cnt) cnt = runIds.Length;

        //        long[] getRuns = new long[2] { 1, 2 };

        //        IList<Run> runList = client.GetRuns(getRuns, false).ToList<Run>();

        //        foreach (Run r in runList)
        //            runs.Add(new RunCollectionData(r));

        //        return runs;
        //    }
        //    return new List<RunCollectionData>();
        //}

    }
}